using System.Collections.Generic;

namespace Patterns.Core.Adapter
{
    public class DuckSimulator : IDuckSimulator
    {
        private IList<IDuck> ducks;

        public DuckSimulator()
        {
            ducks = new List<IDuck>();
        }


        public void Add(IDuck duck)
        {
            ducks.Add(duck);
        }

        public void Simulate()
        {
            foreach (IDuck duck in ducks)
            {
                duck.Fly();
                duck.Swim();
                duck.Quack();
            }
        }
    }
}