using System.Collections.Generic;

namespace Patterns.Core.Strategy
{
    public class ListOfPeopleWithStrategy
    {
        private List<Person> people;

        public ListOfPeopleWithStrategy()
        {
            people = new List<Person>();
        }


        public Person this[int index]
        {
            get { return people[index]; }
            set { people[index] = value; }
        }

        public void Add(Person person)
        {
            people.Add(person);
        }

        public void Sort(IComparer<Person> comparer)
        {
            people.Sort(comparer);
        }
    }
}