using Patterns.Core.Adapter;

namespace Patterns.Core.Task
{
    public class SampleTask
    {
        private IMapperRegistry mapperRegistry;


        public SampleTask() : this(new MapperRegistry())
        {
        }

        public SampleTask(IMapperRegistry mapperRegistry)
        {
            this.mapperRegistry = mapperRegistry;
        }

        public void Insert10People()
        {
            using (UnitOfWork uow = new UnitOfWork(mapperRegistry))
            {
                for (int i = 0; i < 10; i++)
                {
                    uow.RegisterNew(new Person(i.ToString(), i));
                }
            }
        }

        public void Insert10PeopleAnd5Ducks()
        {
            using (UnitOfWork uow = new UnitOfWork(mapperRegistry))
            {
                for (int i = 0; i < 10; i++)
                {
                    uow.RegisterNew(new Person(i.ToString(), i));
                }
                for (int i = 0; i < 5; i++)
                {
                    uow.RegisterNew(new MallardDuck());
                }
            }
        }
    }
}