using System;
using System.Collections.Generic;

namespace Patterns.Core.Task
{
    public class UnitOfWork : IDisposable
    {
        private IList<object> workingSet;
        private IMapperRegistry registry;


        public UnitOfWork(IMapperRegistry registry)
        {
            this.registry = registry;
            workingSet = new List<object>();
        }

        public UnitOfWork() : this(new MapperRegistry())
        {
        }

        public void RegisterNew(object item)
        {
            workingSet.Add(item);
        }

        public void Dispose()
        {
            Commit();
        }

        private void Commit()
        {
            foreach (object item in workingSet)
            {
                registry.GetMapperFor(item.GetType()).Insert(item);
            }
        }
    }
}