using NUnit.Framework;
using Patterns.Core.Adapter;

namespace Patterns.Test.Adapter
{
    [TestFixture]
    public class AdapterTest
    {
        [Test]
        public void ShouldProcessDucks()
        {
            IDuckSimulator simulator = new DuckSimulator();

            for (int i = 0; i < 4; i++)
            {
                simulator.Add(new MallardDuck());
                simulator.Add(new DogDuckAdapter(new GermanShepherd()));
            }
            simulator.Simulate();
        }
    }
}