using NUnit.Framework;
using Patterns.Core;
using Patterns.Core.Singleton;

namespace Patterns.Test.Singleton
{
    [TestFixture]
    public class SingletonTest
    {
        [Test]
        public void ShouldLog()
        {
            Logger.Instance.Log();
        }

        [Test]
        public void ShouldBeAbleToTestIndependentlyByMockingOutDependency()
        {
            SomeClassThatNeedsLogging someClassThatNeedsLogging = new SomeClassThatNeedsLogging(new MockLogger());
        }

        private class MockLogger : ILogger
        {
            public void Log()
            {
            }
        }
    }

    public class SomeClassThatNeedsLogging
    {
        private ILogger logger;


        public SomeClassThatNeedsLogging() : this(Logger.Instance)
        {
        }

        public SomeClassThatNeedsLogging(ILogger logger)
        {
            this.logger = logger;
        }

        public void SomeMethod()
        {
            logger.Log();
        }
    }
}