using System;
using NUnit.Framework;
using Patterns.Core;
using Patterns.Core.Strategy;

namespace Patterns.Test.Strategy
{
    [TestFixture]
    public class RefactoredStrategyTest
    {
        [Test]
        public void ShouldSort()
        {
            Person charlie = new Person("Charlie", 27, new DateTime(2006, 1, 1));
            Person david = new Person("David", 27, new DateTime(1950, 1, 1));
            Person peter = new Person("Peter", 27, new DateTime(1960, 1, 1));

            ListOfPeopleWithStrategy people = new ListOfPeopleWithStrategy();
            people.Add(peter);
            people.Add(david);
            people.Add(charlie);


            people.Sort(new BirthDayComparer());

            Assert.AreEqual(david, people[0]);
            Assert.AreEqual(peter, people[1]);
            Assert.AreEqual(charlie, people[2]);
        }
    }
}